<?php
// PHP script by newquayweather.com
// 
// Version 1.00 - 20-Jul-2009 -- Initial release
// Version 1.10 - preg_replace added
// Version 1.20 - modified to grab new day and add to current year file
// Version 1.30 - Modified after swpc website change to use file_get_contents
// 
// Called by a cron job after 02:30am UT, re time difference
// Example how a cron might look
// 25	21	*	*	*	/ramdisk/bin/php5 /home/xxxxx/public_html/xxxxx/sunspots/sunspots_cron_yr.php >/dev/null
// Trial and error for time depending on your time zone, server location
// Set up cron job in cPanel
// Change paths to match your site
// Place sunspots_cron_yr.php in sunspots directory 
// refresh cached copy of page if needed
// 
//
  $Version = 'sunspots_current_yr.php V1.30 - 12-Jan-2015';
//
// cacheName is name of file used to store cached webpage
//

  $cacheName = "sunspots.txt";  // used to store the file so we don't have to
//                                 fetch every page load
  $refetchSeconds = 3600;     // refetch every nnnn seconds 3600 = 1 hour

// Sunspot daily totals URL
// 
//  $fileName = "http://www.swpc.noaa.gov/ftpdir/latest/DSD.txt";
  $ftp_server = "ftp://ftp.swpc.noaa.gov/pub/latest/DSD.txt";

  $currentyr = "/home/xxxxx/public_html/xxxxx/sunspots/".date("Y")."/".date("Y")."_DSD.txt";

//
// ------ start of code -------
// check year dir exists
if (!is_dir('/home/xxxx/public_html/xxxxx/sunspots/'.date("Y"))) {
    mkdir('/home/xxxxx/public_html/xxxxxx/sunspots/'.date("Y"));
}
//
// end of settings
if (file_exists($cacheName) and filemtime($cacheName) + $refetchSeconds > time()) {
      $text = implode('', file($cacheName));
    } else {

$ctx = stream_context_create(array('http' => array('timeout' => 10)));

$text=@file_get_contents($ftp_server, 0, $ctx);

if ($text == "") {
//   throw new Exception("php error message = " . "false");
echo 'Missing cache file or ';
$text=false;
} else {
      $fp = fopen($cacheName, "w");
      if ($fp) {
        $write = fputs($fp, $text);
        fclose($fp);
      } else {
            print "error cant find cache file - $cacheName<br />";
      }
	}
}


$split = preg_split("/[\n]/", $text, -1, 0 );

$lastline = count($split)-2;

$last = $split[$lastline] . "\n";

// new only required for email
 $dayspots = explode(" ", $last);
$yr = $dayspots[0]; // year
$mth = $dayspots[1]; // month
$dy = $dayspots[2]; // day
$spots = $dayspots[8]; // spots
$cyear = $dy."-".$mth."-".$yr;
// end


// save file
      $fp = fopen($currentyr, "a");
      if ($fp) {
        $write = fputs($fp, $last);
        fclose($fp);
      } else {
//            print "error";
      }

// ----------------------------functions ----------------------------------- 

// --------------end of functions ---------------------------------------
?>
